var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import { css } from '@patternfly/react-styles';
import PropTypes from 'prop-types';
import styled from 'react-emotion';
import { flexWrap, flexDirection, alignItems, alignContent, justifyContent } from 'styled-system';
import StyledBox, { StyledBoxBase } from './StyledBox';

var StyledFlexBase = styled(StyledBoxBase)({
  display: 'flex'
},
// flex parent props
flexWrap, flexDirection, alignItems, alignContent, justifyContent);

/**
 * StyledFlex inherits all the props from the StyledBox component.
 */
var StyledFlex = function StyledFlex(_ref) {
  var className = _ref.className,
      children = _ref.children,
      component = _ref.component,
      props = _objectWithoutProperties(_ref, ['className', 'children', 'component']);

  var StyledFlexBaseWithComponent = StyledFlexBase.withComponent(component);
  return React.createElement(
    StyledFlexBaseWithComponent,
    _extends({}, props, { className: css(className) }),
    children
  );
};

StyledFlex.propTypes = _extends({}, StyledBox.propTypes, {

  /** flex-wrap */
  flexWrap: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** flex-direction */
  flexDirection: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** align-items */
  alignItems: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** align-content */
  alignContent: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array]),
  /** justify-content */
  justifyContent: PropTypes.oneOfType([PropTypes.number, PropTypes.string, PropTypes.array])
});

StyledFlex.defaultProps = _extends({}, StyledBox.defaultProps, {

  flexWrap: null,
  flexDirection: null,
  alignItems: null,
  alignContent: null,
  justifyContent: null
});

export default StyledFlex;